using CallCenter.Utility;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
    /// T_Sys_AreaChildren
    /// </summary>
    public partial class T_Sys_AreaChildren
    {
        private readonly CallCenterApi.DAL.T_Sys_AreaChildren dal = new CallCenterApi.DAL.T_Sys_AreaChildren();
        public T_Sys_AreaChildren()
        { }
        #region  BasicMethod

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_AreaChildren model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_AreaChildren model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_AreaId)
        {

            return dal.Delete(F_AreaId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_AreaIdlist)
        {
            return dal.DeleteList(F_AreaIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_AreaChildren GetModel(int F_AreaId)
        {

            return dal.GetModel(F_AreaId);
        }

        

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Sys_AreaChildren> GetModelList(string strWhere)
        {
            var dt = GetRedis();
            if (dt != null)
            {
                var dtnew = new DataTable();
                var drs = dt.Select(strWhere);
                if (drs.Length > 0)
                {
                    dtnew = drs.CopyToDataTable();
                }
                return DataTableToList(dtnew);
            }
            else
            {
                DataSet ds = dal.GetList(strWhere);
                return DataTableToList(ds.Tables[0]);
            }
        }
        private DataTable GetRedis()
        {
            var strList = RedisHelper.StringGet("T_Sys_AreaChildren");
            if (strList != null)
            {
                return strList.ToString().ToObject<DataTable>();
            }
            else
            {
                return InRedis();
            }
        }
        private DataTable InRedis()
        {
            var dt = dal.GetList("").Tables[0];

            RedisHelper.StringSet("T_Sys_AreaChildren", dt.ToJson(), new TimeSpan(24, 0, 0));

            return dt;
        }

        private void OutRedis()
        {
            RedisHelper.KeyDelete("T_Sys_AreaChildren");
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Sys_AreaChildren> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Sys_AreaChildren> modelList = new List<CallCenterApi.Model.T_Sys_AreaChildren>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Sys_AreaChildren model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        //public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        //{
        //return dal.GetList(PageSize,PageIndex,strWhere);
        //}

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
